#include <stdio.h>
#include <string.h>

typedef unsigned long ulong;

int main(void)
{
  ulong a, n, p;
  int digit, listo, longn;
  int acola, fcola, tcola, ncola;
  char num[10], act[10], cola[18];
  FILE *ent, *sal;

  ent = fopen("nen.ent", "r");
  fscanf(ent, "%lu", &n);
  fclose(ent);

  listo = fcola = tcola = ncola = 0;
  sprintf(num, "%lu", n);
  longn = strlen(num);
  a = 1;
  p = 0;

/* Esta es la solucion lenta: Mientras no hayamos encontrado el numero
pedido (y lo encontraremos), primero vemos si hay suficientes digitos en 
una cola circular o no. Si no hay, agregamos un numero nuevo, si hay 
entonces comparamos desde el frente de la cola con el numero buscado. Si 
no coincide, sacamos un elemento de la cola, o ya terminamos */

  while (!listo) {
    if (ncola < longn) {
      sprintf(act, "%lu", a++);
      for (digit = 0; act[digit]; digit++) {
	cola[tcola++] = act[digit];
	tcola %= 18;
	ncola++;
      }
    } else {
      listo = 1;
      for (digit = 0; listo && num[digit]; digit++)
	if (cola[(fcola+digit)%18] != num[digit])
	  listo = 0;
      fcola++;
      fcola %= 18;
      ncola--;
      p++;
    }
  }

/* Hay mejores soluciones? Claro! */

  sal = fopen("nen.sal", "w");
  fprintf(sal, "%lu\n", p);
  fclose(sal);
  return 0;
}
