#include <stdio.h>

int main(void)
{
  int h, i, j, k, m, n, ic, jc;
  int altura, cimas, listo, total;
  int a[102][102], x[102][102];
  FILE *ent, *sal;

/* Las matrices a y x tienen dos lugares mas de los
necesarios para ahorrar verificar casos especiales */

  ent = fopen("blm.ent", "r");
  fscanf(ent, "%d%d", &m, &n);
  for (i = 1; i <= m; i++)
    for (j = 1; j <= n; j++)
      fscanf(ent, "%d", &x[i][j]);

/* al principio no hay cimas */

  cimas = 0;
  altura = -1000;
  for (i = 1; i <= m; i++)
    for (j = 1; j <= n; j++)
      if (x[i][j] > altura) { /* una posible cima nueva */
	ic = i;
	jc = j;
	altura = x[i][j];
	cimas = 1;
      } else if (x[i][j] == altura)
	cimas++; /* otra posible cima a la misma altura */

  for (i = 0; i <= m+1; i++)
    for (j = 0; j <= n+1; j++)
      a[i][j] = 0;
  a[ic][jc] = 1;

/* a[i][j] = 1 solo si se puede llegar desde una cima */

  do {
    listo = 1;
    for (i = 1; i <= m; i++)
      for (j = 1; j <= n; j++)
	if (!a[i][j]) {

/* si no he llegado aqui, revisa sus cuatro vecinos */

	  if (a[i-1][j] && (x[i-1][j] >= x[i][j])) {
	    a[i][j] = 1;
	    listo = 0;
	  }
	  if (a[i+1][j] && (x[i+1][j] >= x[i][j])) {
	    a[i][j] = 1;
	    listo = 0;
	  }
	  if (a[i][j-1] && (x[i][j-1] >= x[i][j])) {
	    a[i][j] = 1;
	    listo = 0;
	  }
	  if (a[i][j+1] && (x[i][j+1] >= x[i][j])) {
	    a[i][j] = 1;
	    listo = 0;
	  }
	}
  } while (!listo);

  total = 0;
  for (i = 1; i <= m; i++)
    for (j = 1; j <= n; j++)
      if (a[i][j])
	total++;

/* si no llegue a todas partes, no hay cimas */

  if (total < m*n)
    cimas = 0;

  sal = fopen("blm.sal", "w");
  fprintf(sal, "%d\n", cimas);
  fclose(sal);
  return 0;
}
